在VictoriaMetrics中，多租户支持是通过租户ID来实现的。VictoriaMetrics本身并不需要显式地“添加”或“创建”租户。相反，租户是通过在写入和查询请求中使用不同的租户ID来实现的。这使得租户管理非常灵活和简单。

### 如何使用多租户功能

1. **写入数据到指定租户**

   当你将数据写入VictoriaMetrics时，可以通过在请求URL中指定租户ID来区分数据属于哪个租户。例如：

   - 默认租户（ID为0）：

     ```plaintext
     http://vminsert.example.com:8480/insert/0/prometheus/
     ```

   - 自定义租户（ID为123）：

     ```plaintext
     http://vminsert.example.com:8480/insert/123/prometheus/
     ```

   在这个例子中，`123`是自定义的租户ID。你可以根据需要选择任意整数作为租户ID。

2. **查询特定租户的数据**

   当查询数据时，也需要在查询请求中指定租户ID，以确保查询的是正确的数据集。对于Prometheus兼容的查询API，你可以这样指定：

   - 查询默认租户的数据：

     ```plaintext
     http://vmselect.example.com:8481/select/0/prometheus/api/v1/query?query=...
     ```

   - 查询租户`123`的数据：

     ```plaintext
     http://vmselect.example.com:8481/select/123/prometheus/api/v1/query?query=...
     ```

### 重要注意事项

- **租户ID是逻辑概念**：VictoriaMetrics没有像传统数据库那样的租户“创建”过程。租户ID的使用仅仅是通过在请求中指定不同的ID来实现数据的逻辑隔离。

- **权限管理**：原生的VictoriaMetrics不包含复杂的权限管理系统。如果需要对租户进行权限或安全管理，通常需要在应用层或者通过其他工具（如反向代理或API网关）来实现。

- **数据隔离**：使用不同的租户ID确保数据的存储和查询是隔离的，但物理上数据仍然可能存储在同一个数据库集群中。

通过这种简单的机制，VictoriaMetrics可以轻松地支持多租户环境，而无需复杂的配置和管理。