在macOS上，你可以使用`du`命令来统计当前文件夹及其子文件夹的磁盘空间使用情况。这里有几个常用的命令选项可以帮助你实现这一目标：

### 使用 `du` 命令

1. **显示当前文件夹及其子文件夹的磁盘使用情况**

   打开“终端”应用程序，然后导航到你想要检查的目录，或者直接在终端中输入以下命令：

   ```bash
   du -h
   ```

   这个命令会递归地显示当前目录及其所有子目录的磁盘使用情况，`-h`选项将结果以人类可读的格式（如KB、MB、GB）显示。

2. **显示当前文件夹及其子文件夹的总磁盘使用情况**

   如果你只想查看当前目录及其子目录的总磁盘使用情况，而不需要详细的目录列表，可以使用：

   ```bash
   du -sh
   ```

   这里，`-s`选项表示“summary”，即只显示总计的大小。

3. **显示指定层级的子目录磁盘使用情况**

   如果你想限制显示的目录层级，可以使用`--max-depth`选项。例如：

   ```bash
   du -h --max-depth=1
   ```

   这个命令会显示当前目录下的每个子目录的磁盘使用情况，但不再深入子目录的子目录。

### 示例

假设你在终端中导航到某个目录，并运行`du -sh`，输出可能类似于：

```plaintext
1.2G	.
```

这表示当前目录及其所有子目录总共占用了1.2GB的磁盘空间。

### 其他注意事项

- `du`命令可能需要一些时间来计算特别是对于包含大量文件或大文件的目录。
- 权限问题可能会导致`du`无法访问某些目录。在这种情况下，可能需要使用`sudo`来提升权限，例如：`sudo du -sh`。
- 如果你对某些特定文件类型的大小感兴趣，可能需要结合其他命令（如`find`）来实现更复杂的过滤和统计。