```go
func ExponentialRandom(lambda float64) float64 {
	rand.Seed(time.Now().UnixNano())
	uniform := rand.Float64()
	return -lambda * math.Log(1.0-uniform)
}

func NormalDistribution(mean float64, stdDev float64) float64 {
	rand.Seed(time.Now().UnixNano())
	uniform := rand.Float64()
	exponent := -math.Pow((uniform-mean), 2) / (2 * math.Pow(stdDev, 2))
	coefficient := 1 / (stdDev * math.Sqrt(2*math.Pi))
	result := coefficient * math.Exp(exponent)
	return result*stdDev + mean
}
```

