### 概念
- 计算机与计算机之间通过网络实现通信时事先达成的一种“约定”
- 使那些由不同厂商的设备，不同的 CPU 以及不同的操作系统组成的计算机之间，只要遵循相同的协议就能够实现通信，反之，如果协议不同，就无法通信
- 协议可以分为很多种，每一种协议都明确的界定了它的行为规范
- 两台计算机之间必须能够支持相同的协议，并遵循相同协议进行处理，才能实现互相通信
![0ebd3ca9f7ddbf9e5dc52446e22995e4.png](../../_resources/0ebd3ca9f7ddbf9e5dc52446e22995e4.png)

### 分组交换协议
- 将大数据分割为一个个叫做包的较小单位进行传输的方法
- 每一个分组中附加上源主机地址和目标主机地址送给通信线路，发送端地址，接收端地址以及分组序号写的部分叫做“报文首部”


### OSI七层模型
- 应用层
- 表示层
- 会话层
- 网络层
- 数据链路层
- 物理层
- 上下层之间交互遵循的约定叫做`接口`
- 同一层交互遵循的约定叫做`协议`
![d9e84b7b4e975ae227430434f3768c15.png](../../_resources/d9e84b7b4e975ae227430434f3768c15.png)


### OSI优点与劣势
- 优点1：每个分层可以独立使用，即使系统中的某些分层发生变化，也不会波及整个系统，因此可以构造一个扩展性和灵活性都很强的系统
- 优点2：分层能够系统通信功能，更易于单独实现每个分层的协议，并界定各个分层的具体责任和义务
- 劣势：过分模块化，式处理变得更加沉重以及每个模块都不得不实现相似的处理逻辑

### OSI各个分层的作用
- 作用具体表格
![35d9622d638eaac96466c765d9bf1092.png](../../_resources/35d9622d638eaac96466c765d9bf1092.png)

- 示意图
![81661e9a437155916091b778a65f9e22.png](../../_resources/81661e9a437155916091b778a65f9e22.png)