```
server {
	listen *:9090;
	server_name gitlab.heysq.com;
	server_tokens off;
	root /opt/gitlab/embedded/service/gitlab-rails/public;
	client_max_body_size 250m;
	access_log  /var/log/gitlab/gitlab_access.log;
  	error_log    /var/log/gitlab/gitlab_error.log;

  location / {
	proxy_read_timeout 300; # Some requests take more than 30 seconds.
    	proxy_connect_timeout 300; # Some requests take more than 30 seconds.
    	proxy_redirect     off;

   	proxy_set_header   X-Forwarded-Proto $scheme;
    	proxy_set_header   Host              $http_host;
    	proxy_set_header   X-Real-IP         $remote_addr;
    	proxy_set_header   X-Forwarded-For   $proxy_add_x_forwarded_for;
    	proxy_set_header   X-Frame-Options   SAMEORIGIN;

    	proxy_pass http://10.44.147.76:9090;
  }
}
```