### 1、概念

- Internet Protocol 网际协议
- 主要负责将数据包发送给最终的目标计算机
- 实现终端节点之间的通信，也叫`点对点通信`

### 2、跳 Hop

- 网络中的一个区间
- 利用数据链路层以下分层的功能传输数据帧的一个区间
- 以太网等数据链路中使用MAC地址进行传输数据帧，此时的一跳是指从源MAC地址到目的MAC地址之间传输帧的区间，也就是说它是主机或路由器网卡不经其他路由器而能直接到达的相邻主机或路由器网卡之间的一个区间
- 在一跳的区间内，电缆可以通过网桥或交换集线器项链，不会通过路由器或网关相连
- 路由器或主机在转发IP数据包时只指定下一个路由器或主机，不会将到最终目标地址为止的所有通路全部指定出来
- 每个区间在转发IP数据包时会分别指定下一跳的操作，直至包达到最终的目的地址

![image-20230708153314081](https://blog-heysq-1255479807.cos.ap-beijing.myqcloud.com/blog/note/image-20230708153314081.png)

### 3、IP协议面向无连接

- 原因
  - 简化
  - 提速
- 提供尽力服务，尽最大努力传递包，不做最终对方收到与否的验证

### 4、IP地址分类

- A：第一位是0，0.0.0.0~127.0.0.0，24位主机号，可容纳地址上限为16777214个
- B：前两位是10，128.0.0.1~191.255.0.0，16位主机号，可容纳地址上限为65534个
- C：前三位是110，192.168.0.0~239.255.255.0，8位主机号，可容纳地址上限为254个
- D：前四位是1110，224.0.0.0~239.255.255.255，没有主机标识，常被用于多播

### 5、广播

- 主机号部分全部设置为1，就是广播地址，172.16.0.0/16的广播地址172.16.255.255
- 本地广播：向同网段内的广播地址发送数据
- 直接广播：向不通网段内的广播地址发送广播数据

![image-20230708180333693](https://blog-heysq-1255479807.cos.ap-beijing.myqcloud.com/blog/note/image-20230708180333693.png)

### 6、IP多播

- 将包发送给特定组内的所有主机

- 使用D类地址，从首位开始到第4位是1110，剩下的28位可以成为多播的组播号

- 相比广播之下，多播可以穿透路由器

- 地址范围 224.0.0.0~239.255.255.255

![image-20230708181537396](https://blog-heysq-1255479807.cos.ap-beijing.myqcloud.com/blog/note/image-20230708181537396.png)

![image-20230708195723407](https://blog-heysq-1255479807.cos.ap-beijing.myqcloud.com/blog/note/image-20230708195723407.png)

### 7、显式拥塞通知

- Explicit Congestion Notification
- IP层新增的一种显式拥塞通知的机制
- 将IP首部的TOS字段置换为ENC字段，并在TCP首部的保留位中追加CRW标志和ECE标志
  - CWR：Congestion Window Reduced
  - ECE：ECN-Echo
- 在发送包的IP首部中记录路由器是否遇到了拥塞，并在返回包的TCP首部中通知是否发生过拥塞
- 拥塞的检测发生在网络层，拥塞的通知在传输层

![image-20230709202410792](https://blog-heysq-1255479807.cos.ap-beijing.myqcloud.com/blog/note/image-20230709202410792.png)
